Subject: Re: [S390] ftrace: update system call tracer support

From: Martin Schwidefsky <[email-masked]>
Date: Tue, 18 Aug 2009 12:22:39 +0200

On Tue, 18 Aug 2009 12:05:26 +0200
Ingo Molnar <[email-masked]> wrote:

> 
> * Martin Schwidefsky <[email-masked]> wrote:
> 
> > On Tue, 18 Aug 2009 10:51:10 +0200
> > Ingo Molnar <[email-masked]> wrote:
> > 
> > > 
> > > * Ingo Molnar <[email-masked]> wrote:
> > > 
> > > > * Paul Mundt <[email-masked]> wrote:
> > > > 
> > > > > [ Adding to Cc everyone that now has a broken tree thanks to this .. ]
> > > > > 
> > > > > On Wed, Aug 12, 2009 at 11:11:33AM +0200, Ingo Molnar wrote:
> > > > > > * Frederic Weisbecker <[email-masked]> wrote:
> > > > > > > This pull request integrate one cleanup/fix for ftrace and an 
> > > > > > > update for syscall tracing: the migration from old-style tracer to 
> > > > > > > individual tracepoints/trace_events and the support for perf 
> > > > > > > counter.
> > > > > > > 
> > > > > > > I've tested it with success either with ftrace (every syscall 
> > > > > > > tracepoints enabled at the same time without problems) and with 
> > > > > > > perfcounter.
> > > > > > > 
> > > > > > > May be one drawback: it creates so much trace events that the 
> > > > > > > ftrace selftests can take some time :-)
> > > > > > 
> > > > > > Pulled, thanks a lot!
> > > > > 
> > > > > And this has now subsequently broken every single SH and S390 
> > > > > configuration, [...]
> > > > 
> > > > I test SH cross-builds regularly. I just checked the SH defconfig 
> > > > and it builds just fine here:
> > > > 
> > > > $ make -j32 CROSS_COMPILE=sh3-linux- ARCH=sh vmlinux
> > > 
> > > The s390 build indeed broke. (This got masked by the s390 toolchain 
> > > i'm using not having been able to build Linus's tree - i fixed 
> > > that.)
> > > 
> > > Could you try the fix below? It does the trick here.
> > > 
> > > Martin, Heiko - does the fix look good to you? regs->gprs[2] seems 
> > > to be the register used for both the syscall number (enter 
> > > callback) and for the return code (exit callback).
> > 
> > Correct, for do_syscall_trace_{enter,exit} the code in entry.S 
> > stores the system call number in regs->gprs[2]. The fix is fine. 
> > Thanks Ingo.
> 
> Thanks, i've added your Acked-by to the commit. I suspect you dont 
> want to pull tracing infrastructure changes into the S390 tree, so 
> keeping this fix in the tracing tree would be the best option?

Indeed, the patch that introduced the api change is in the tracing tree
so it makes sense to put the s390 adaptions there too.

-- 
blue skies,
   Martin.

"Reality continues to ruin my life." - Calvin.